/******************** (C) COPYRIGHT 2006 STMicroelectronics ********************
* File Name          : usb_int.c
* Author             : MCD Application Team
* Date First Issued  : 10/27/2003 : V1.0
* Description        : Interface functions to USB cell registers
********************************************************************************
* History:
* 06/12/2006 : V2.0  Beta
* 10/27/2003 : V1.0
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "usb_lib.h"
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Extern variables ----------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
/*******************************************************************************
* Function Name  : SetCNTR
* Description    :
* Input          : wRegValue
* Output         : None
* Return         : None
*******************************************************************************/
void SetCNTR(u16 wRegValue )
{
	_SetCNTR(wRegValue);
}
/*******************************************************************************
* Function Name  : GetCNTR
* Description    :
* Input          : None
* Output         : None
* Return         : CNTR register Value
*******************************************************************************/
u16 GetCNTR(void)
{
	return(_GetCNTR());
}
/*******************************************************************************
* Function Name  : SetISTR
* Description    :
* Input          : wRegValue
* Output         : None
* Return         : None
*******************************************************************************/
void SetISTR(u16 wRegValue )
{
	_SetISTR(wRegValue);
}
/*******************************************************************************
* Function Name  : GetISTR
* Description    :
* Input          :
* Output         :
* Return         : ISTR register Value
*******************************************************************************/
u16 GetISTR(void)
{
	return(_GetISTR());
}
/*******************************************************************************
* Function Name  : GetFNR
* Description    :
* Input          :
* Output         :
* Return         : FNR register Value
*******************************************************************************/
u16 GetFNR(void)
{
	return(_GetFNR());
}
/*******************************************************************************
* Function Name  : SetDADDR
* Description    :
* Input          : wRegValue
* Output         :
* Return         :
*******************************************************************************/
void SetDADDR(u16 wRegValue )
{
	_SetDADDR(wRegValue);
}
/*******************************************************************************
* Function Name  : GetDADDR
* Description    :
* Input          :
* Output         :
* Return         : DADDR register Value
*******************************************************************************/
u16 GetDADDR(void)
{
	return(_GetDADDR());
}
/*******************************************************************************
* Function Name  : SetBTABLE
* Description    :
* Input          : wRegValue
* Output         :
* Return         :
*******************************************************************************/
void SetBTABLE(u16 wRegValue )
{
	_SetBTABLE(wRegValue);
}

/*******************************************************************************
* Function Name  : GetBTABLE
* Description    :
* Input          :
* Output         :
* Return         : BTABLE address
*******************************************************************************/
u16 GetBTABLE(void)
{
	return(_GetBTABLE());
}
/*******************************************************************************
* Function Name  : SetENDPOINT
* Description    :
* Input          : bEpNum, wRegValue
* Output         :
* Return         :
*******************************************************************************/
void SetENDPOINT(u8 bEpNum, u16 wRegValue )
{
	_SetENDPOINT(bEpNum,wRegValue);
}
/*******************************************************************************
* Function Name  : GetENDPOINT
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
u16 GetENDPOINT(u8 bEpNum)
{
	return(_GetENDPOINT(bEpNum));
}
/*******************************************************************************
* Function Name  : SetEPType
* Description    :
* Input          : bEpNum, wType
* Output         :
* Return         :
*******************************************************************************/
void SetEPType(u8 bEpNum, u16 wType)
{
	_SetEPType(bEpNum, wType);
}
/*******************************************************************************
* Function Name  : GetEPType
* Description    :
* Input          : bEpNum,
* Output         :
* Return         : Endpoint Type
*******************************************************************************/
u16 GetEPType(u8 bEpNum)
{
	return(_GetEPType(bEpNum));
}
/*******************************************************************************
* Function Name  : SetEPTxStatus
* Description    :
* Input          : bEpNum, wState
* Output         :
* Return         :
*******************************************************************************/
void SetEPTxStatus(u8 bEpNum, u16 wState)
{
	_SetEPTxStatus(bEpNum,wState);
}
/*******************************************************************************
* Function Name  : SetEPRxStatus
* Description    :
* Input          : bEpNum, wState
* Output         :
* Return         :
*******************************************************************************/
void SetEPRxStatus(u8 bEpNum, u16 wState)
{
	_SetEPRxStatus(bEpNum,wState);
} /* SetEPRxStatus */
/*******************************************************************************
* Function Name  : SetDouBleBuffEPStall
* Description    : sets the status for Double Buffer Endpoint to STALL
* Input          : bEpNum = endpoint number
	           bDir = Endpoint direction
* Output         :
* Return         :
*******************************************************************************/
void SetDouBleBuffEPStall(u8 bEpNum,u8 bDir)
{
  u16 Endpoint_DTOG_Status;
  Endpoint_DTOG_Status = GetENDPOINT(bEpNum);
 if(bDir== EP_DBUF_OUT)
   { /* OUT double buffered endpoint */
   _SetENDPOINT(bEpNum, Endpoint_DTOG_Status & ~EPRX_DTOG1);
   }
   else if(bDir == EP_DBUF_IN)
   { /* IN double buffered endpoint */
   _SetENDPOINT(bEpNum, Endpoint_DTOG_Status & ~EPTX_DTOG1);
   }
}
/*******************************************************************************
* Function Name  : GetEPTxStatus
* Description    :
* Input          : bEpNum
* Output         :
* Return         : Endpoint TX Status
*******************************************************************************/
u16 GetEPTxStatus(u8 bEpNum)
{
	return(_GetEPTxStatus(bEpNum));
}/*GetEPTxStatus */
/*******************************************************************************
* Function Name  : GetEPRxStatus
* Description    :
* Input          : bEpNum
* Output         :
* Return         : Endpoint RX Status
*******************************************************************************/
u16 GetEPRxStatus(u8 bEpNum)
{
	return(_GetEPRxStatus(bEpNum));
}
/*******************************************************************************
* Function Name  : SetEPTxValid
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void SetEPTxValid(u8 bEpNum)
{
 	_SetEPTxStatus(bEpNum, EP_TX_VALID);
}
/*******************************************************************************
* Function Name  : SetEPRxValid
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void SetEPRxValid(u8 bEpNum)
{
 	_SetEPRxStatus(bEpNum, EP_RX_VALID);
}
/*******************************************************************************
* Function Name  : SetEP_KIND
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void SetEP_KIND(u8 bEpNum)
{
	_SetEP_KIND(bEpNum);
}
/*******************************************************************************
* Function Name  : ClearEP_KIND
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void ClearEP_KIND(u8 bEpNum)
{
	_ClearEP_KIND(bEpNum);
}
/*******************************************************************************
* Function Name  : Clear_Status_Out
* Description    : Clear the Status Out of the related Endpoint
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void Clear_Status_Out(u8 bEpNum){
	 _ClearEP_KIND(bEpNum);
}
/*******************************************************************************
* Function Name  : Set_Status_Out
* Description    : Set the Status Out of the related Endpoint
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void Set_Status_Out(u8 bEpNum)
{
	_SetEP_KIND(bEpNum);
}
/*******************************************************************************
* Function Name  : SetEPDoubleBuff
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void SetEPDoubleBuff(u8 bEpNum)
{
	 _SetEP_KIND(bEpNum);
}
/*******************************************************************************
* Function Name  : ClearEPDoubleBuff
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void ClearEPDoubleBuff(u8 bEpNum)
{
	 _ClearEP_KIND(bEpNum);
}
/*******************************************************************************
* Function Name  : GetTxStallStatus
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
u16 GetTxStallStatus(u8 bEpNum)
{
	return(_GetTxStallStatus(bEpNum));
}
/*******************************************************************************
* Function Name  : GetRxStallStatus
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
u16 GetRxStallStatus(u8 bEpNum)
{
	return(_GetRxStallStatus(bEpNum));
}
/*******************************************************************************
* Function Name  : ClearEP_CTR_RX
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void ClearEP_CTR_RX(u8 bEpNum)
{
	_ClearEP_CTR_RX(bEpNum);
}
/*******************************************************************************
* Function Name  : ClearEP_CTR_TX
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void ClearEP_CTR_TX(u8 bEpNum)
{
	_ClearEP_CTR_TX(bEpNum);
}
/*******************************************************************************
* Function Name  : ToggleDTOG_RX
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void ToggleDTOG_RX(u8 bEpNum)
{
	_ToggleDTOG_RX(bEpNum);
}
/*******************************************************************************
* Function Name  : ToggleDTOG_TX
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void ToggleDTOG_TX(u8 bEpNum)
{
	_ToggleDTOG_TX(bEpNum);
}
/*******************************************************************************
* Function Name  : ClearDTOG_RX
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void ClearDTOG_RX(u8 bEpNum)
{
	_ClearDTOG_RX(bEpNum);
}
/*******************************************************************************
* Function Name  : ClearDTOG_TX
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
void ClearDTOG_TX(u8 bEpNum)
{
	_ClearDTOG_TX(bEpNum);
}
/*******************************************************************************
* Function Name  : SetEPAddress
* Description    :
* Input          : bEpNum, bAddr
* Output         :
* Return         :
*******************************************************************************/
void SetEPAddress(u8 bEpNum,u8 bAddr)
{
	_SetEPAddress(bEpNum,bAddr);
}
/*******************************************************************************
* Function Name  : GetEPAddress
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
u8 GetEPAddress(u8 bEpNum)
{
	return(_GetEPAddress(bEpNum));
}
/*******************************************************************************
* Function Name  : SetEPTxAddr
* Description    :
* Input          : bEpNum,  wAddr
* Output         :
* Return         :
*******************************************************************************/
void SetEPTxAddr(u8 bEpNum, u16 wAddr)
{
	_SetEPTxAddr(bEpNum,wAddr);
}
/*******************************************************************************
* Function Name  : SetEPRxAddr
* Description    :
* Input          : bEpNum,  wAddr
* Output         :
* Return         :
*******************************************************************************/
void SetEPRxAddr(u8 bEpNum, u16 wAddr)
{
	 _SetEPRxAddr(bEpNum,wAddr);
}
/*******************************************************************************
* Function Name  : GetEPTxAddr
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
u16 GetEPTxAddr(u8 bEpNum)
{
	 return(_GetEPTxAddr(bEpNum));
} /* GetEPTxAddr */
/*******************************************************************************
* Function Name  : GetEPRxAddr
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
u16 GetEPRxAddr(u8 bEpNum)
{
	 return(_GetEPRxAddr(bEpNum));
}
/*******************************************************************************
* Function Name  : SetEPTxCount
* Description    :
* Input          : bEpNum, wCount
* Output         :
* Return         :
*******************************************************************************/
void SetEPTxCount(u8 bEpNum, u16 wCount)
{
	_SetEPTxCount(bEpNum,wCount);
}
/*******************************************************************************
* Function Name  : SetEPCountRxReg
* Description    :
* Input          : *pdwReg, wCount
* Output         :
* Return         :
*******************************************************************************/
void SetEPCountRxReg(u32 *pdwReg, u16 wCount)
{
	_SetEPCountRxReg(dwReg, wCount);
}
/*******************************************************************************
* Function Name  : SetEPTxCount
* Description    :
* Input          : bEpNum, wCount
* Output         :
* Return         :
*******************************************************************************/
void SetEPRxCount(u8 bEpNum, u16 wCount)
{
	_SetEPRxCount(bEpNum,wCount);
}
/*******************************************************************************
* Function Name  : GetEPTxCount
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
u16 GetEPTxCount(u8 bEpNum)
{
	 return(_GetEPTxCount(bEpNum));
}
/*******************************************************************************
* Function Name  : GetEPRxCount
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
u16 GetEPRxCount(u8 bEpNum)
{
	 return(_GetEPRxCount(bEpNum));
}
/*******************************************************************************
* Function Name  : SetEPDblBuffAddr
* Description    :
* Input          : bEpNum, wBuf0Addr, wBuf1Addr
* Output         :
* Return         :
*******************************************************************************/
void SetEPDblBuffAddr(u8 bEpNum, u16 wBuf0Addr, u16 wBuf1Addr)
{
	_SetEPDblBuffAddr(bEpNum, wBuf0Addr, wBuf1Addr);
}
/*******************************************************************************
* Function Name  : SetEPDblBuf0Addr
* Description    :
* Input          : bEpNum, wBuf0Addr
* Output         :
* Return         :
*******************************************************************************/
void SetEPDblBuf0Addr(u8 bEpNum,u16 wBuf0Addr)
{
	_SetEPDblBuf0Addr(bEpNum, wBuf0Addr);
}
/*******************************************************************************
* Function Name  : SetEPDblBuf1Addr
* Description    :
* Input          : bEpNum, wBuf1Addr
* Output         :
* Return         :
*******************************************************************************/
void SetEPDblBuf1Addr(u8 bEpNum,u16 wBuf1Addr)
{
	_SetEPDblBuf1Addr(bEpNum, wBuf1Addr);
}
/*******************************************************************************
* Function Name  : GetEPDblBuf0Addr
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
u16 GetEPDblBuf0Addr(u8 bEpNum)
{
	return(_GetEPDblBuf0Addr(bEpNum));
}
/*******************************************************************************
* Function Name  : GetEPDblBuf1Addr
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
u16 GetEPDblBuf1Addr(u8 bEpNum)
{
	return(_GetEPDblBuf1Addr(bEpNum));
}
/*******************************************************************************
* Function Name  : SetEPDblBuffCount
* Description    :
* Input          : bEpNum,bDir, wCount
* Output         :
* Return         :
*******************************************************************************/
void SetEPDblBuffCount(u8 bEpNum, u8 bDir, u16 wCount)
{
	 _SetEPDblBuffCount(bEpNum, bDir, wCount);
}
/*******************************************************************************
* Function Name  : SetEPDblBuf0Count
* Description    :
* Input          : bEpNum, bDir,  wCount
* Output         :
* Return         :
*******************************************************************************/
void SetEPDblBuf0Count(u8 bEpNum, u8 bDir,u16 wCount)
{
	_SetEPDblBuf0Count(bEpNum,bDir,wCount);
}
/*******************************************************************************
* Function Name  : SetEPDblBuf1Count
* Description    :
* Input          : bEpNum,  bDir,  wCount
* Output         :
* Return         :
*******************************************************************************/
void SetEPDblBuf1Count(u8 bEpNum, u8 bDir,u16 wCount)
{
	_SetEPDblBuf1Count(bEpNum,bDir,wCount);
}
/*******************************************************************************
* Function Name  : GetEPDblBuf0Count
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
u16 GetEPDblBuf0Count(u8 bEpNum)
{
	 return(_GetEPDblBuf0Count(bEpNum));
}
/*******************************************************************************
* Function Name  : GetEPDblBuf1Count
* Description    :
* Input          : bEpNum
* Output         :
* Return         :
*******************************************************************************/
u16 GetEPDblBuf1Count(u8 bEpNum)
{
	 return(_GetEPDblBuf1Count(bEpNum));
}
/*******************************************************************************
* Function Name  : GetEPDblBufDir
* Description    : gets direction of the double buffered endpoint
* Input          : bEpNum
* Output         : EP_DBUF_OUT, EP_DBUF_IN,
                   EP_DBUF_ERR if the endpoint counter not yet programmed
* Return         :
*******************************************************************************/
EP_DBUF_DIR GetEPDblBufDir(u8 bEpNum) {
	 if((u16)(*_pEPRxCount(bEpNum) & 0xFC00) != 0)
	 		return(EP_DBUF_OUT);
	 else if(((u16)(*_pEPTxCount(bEpNum)) & 0x03FF) != 0)
	 		return(EP_DBUF_IN);
	 else
	 		return(EP_DBUF_ERR);
}
/*******************************************************************************
* Function Name  : FreeUserBuffer
* Description    : free buffer used from the application realising it to the line
                   toggles bit SW_BUF in the double buffered endpoint register
* Input          : bEpNum, bDir
* Output         :
* Return         :
*******************************************************************************/
void FreeUserBuffer(u8 bEpNum, u8 bDir)
{
   if(bDir== EP_DBUF_OUT)
   { /* OUT double buffered endpoint */
    _ToggleDTOG_TX(bEpNum);
   }
   else if(bDir == EP_DBUF_IN)
   { /* IN double buffered endpoint */
    _ToggleDTOG_RX(bEpNum);
   }
}

/*******************************************************************************
* Function Name  : ToWord
* Description    :
* Input          : bh, bl
* Output         :
* Return         :
*******************************************************************************/
u16 ToWord(u8 bh, u8 bl)
{
 u16 wRet;
   wRet = (u16)bl | ((u16)bh << 8);
   return(wRet);
}
/*******************************************************************************
* Function Name  : ByteSwap
* Description    :
* Input          : wSwW
* Output         :
* Return         :
*******************************************************************************/
u16 ByteSwap(u16 wSwW)
{
 u8 bTemp;
 u16 wRet;
   bTemp = (u8)(wSwW & 0xff);
   wRet =  (wSwW >> 8) | ((u16)bTemp << 8);
   return(wRet);
}

/******************* (C) COPYRIGHT 2006 STMicroelectronics *****END OF FILE****/

